﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Public c32, a8, r8, g8, b8 As Int 'sideA/foreside, format: i32,a8,r8,g8,b8
End Sub

Public Sub Initialize() As Boolean

    c32 = 0
    a8 = 0: r8 = 0: g8 = 0: b8 = 0
End Sub

Public Sub Initialize2(r4 As Int, g4 As Int, b4 As Int) As Boolean

    create3(r4, g4, b4)
End Sub

Public Sub create3(r4 As Int, g4 As Int, b4 As Int) As Boolean

    a8 = 0xFF
    r8 = r4 * 0x11 'factor 17
    g8 = g4 * 0x11 'factor 17
    b8 = b4 * 0x11 'factor 17
    c32 = Colors.ARGB(a8, r8, g8, b8)
End Sub

Public Sub create4(a4 As Int, r4 As Int, g4 As Int, b4 As Int) As Boolean

    a8 = a4 * 0x11 'factor 17
    r8 = r4 * 0x11 'factor 17
    g8 = g4 * 0x11 'factor 17
    b8 = b4 * 0x11 'factor 17
    c32 = Colors.ARGB(a8, r8, g8, b8)
End Sub

Public Sub assign4(a4 As Int, r4 As Int, g4 As Int, b4 As Int, lum As Float) As Boolean

    If lum < 0 Then lum = 0
    If lum > 1 Then lum = 1

    a8 = a4 * 0x11
    r8 = r4 * 0x11 * lum
    g8 = g4 * 0x11 * lum
    b8 = b4 * 0x11 * lum
    c32 = Colors.ARGB(a8, r8, g8, b8)
End Sub

Public Sub assign5(c5 As color5, lum As Float) As Boolean

    If lum < 0 Then lum = 0
    If lum > 1 Then lum = 1

    a8 = c5.a8
    r8 = c5.r8 * lum
    g8 = c5.g8 * lum
    b8 = c5.b8 * lum
    c32 = Colors.ARGB(a8, r8, g8, b8)
End Sub

Public Sub changeAlpha(alpha As Float) As Boolean

    If alpha < 0 Then alpha = 0
    If alpha > 1 Then alpha = 1

    a8 = alpha * 0xFF
    c32 = Colors.ARGB(a8, r8, g8, b8)
End Sub