﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

    Public pnum As Int
    Public fnum As Int

    Public ax0, ay0, az0 As Float  'transformed shape position
    Public ax(), ay(), az() As Float  'node-transformed shape matrix (new)

    'Public ax(), ay(), az() As Float 'transformed matrix ax,ay,az (3x4 matrix represents a pos-axes-system)
    Public px(), py(), pz() As Float     'space-transformed point x,y,z
    Public pcx(), pcy(), pcz() As Float  'cam-transformed point x,y,z
    'Public ppx(), ppy(), ppz() As Float 'projected point x,y,z mit z >= 0
    
    Public fcx(), fcy(), fcz() As Float  'transformed face center-point
    Public fnx(), fny(), fnz() As Float  'transformed face normal-vector
    Public fux(), fuy(), fuz() As Float  'transformed face up-vector

    Public fsides() As Int      'number of sides (1,2)
    
    Public clips_nearZ As Int   'current position rel. to nearZ-plane (0:behind,1:intersect,2:before)
    Public clips_winX  As Int   'current position rel. to windowX-borders (not actively used yet)
    Public clips_winY  As Int   'current position rel. to windowY-borders (not actively used yet)

    Public hrad_inner As Float  'mesh hull inner radius, old: hull_iRadius
    Public hrad_outer As Float  'mesh hull outer radius, old: hull_oRadius
    'Public hrad_screen As Float  'mesh hull screen radius (as of projected to screen)

    Public pro_ax0 As Float    'projected position.x, alt. pp_x
    Public pro_ay0 As Float    'projected position.y, alt. pp_y
    Public pro_az0 As Float    'transformed position.z, alt. pp_z
    Public pro_radius As Float 'projected radius of outer hull, alt. pp_r
End Sub

Public Sub Initialize() As Boolean 'array size adapted to b4a

	Dim ax(4), ay(4), az(4) As Float
End Sub

Public Sub init(pnum0 As Int, fnum0 As Int)

    Dim pm As Int = pnum0: pnum = pm 	'array size adapted to b4a
    Dim fm As Int = fnum0: fnum = fm 

    Dim px(pm), py(pm), pz(pm) As Float
    Dim pcx(pm), pcy(pm), pcz(pm) As Float

    Dim fcx(fm), fcy(fm), fcz(fm) As Float
    Dim fnx(fm), fny(fm), fnz(fm) As Float
    Dim fux(fm), fuy(fm), fuz(fm) As Float
    Dim fsides(fm) As Int
End Sub