﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Public form As xform3

	Public lens_scale As Double

	Public plane_z1 As Double       'z-value of near clipping-plane
	Public plane_z2 As Double       'z-value of far clipping-plane

	Public win_x1, win_x2 As Double 'x-values of left and right clipping-borders
	Public win_y1, win_y2 As Double 'y-values of upper and lower clipping-borders
	Public win_cx As Double
	Public win_cy As Double
End Sub

Public Sub Initialize() As Boolean

    init
End Sub

Private Sub init()

    form.Initialize

    plane_z1 = 1
    plane_z2 = 1000
    lens_scale = 100
    win_cx = 200
    win_cy = 320
    win_x1 = -win_cx*0.5: win_y1 = -win_cy*0.5
    win_x2 =  win_cx*0.5: win_y2 =  win_cy*0.5
End Sub

Public Sub setPlanes(z1 As Double, z2 As Double)

    plane_z1 = z1
    plane_z2 = z2
End Sub

'old: setLens(scaleX As Double, scaleY As Double)
Public Sub setLens(scale As Double)

    lens_scale = scale
End Sub

Public Sub assignWindow(w As window3)
    
    win_cx = w.centerX
    win_cy = w.centerY
    win_x1 = w.x1: win_y1 = w.y1
    win_x2 = w.x2: win_y2 = w.y2

    'setLens ((w.sizeX + w.sizeY) / 4)
    'setLens ((w.sizeX + w.sizeY) / 2)
    setLens ((w.sizeX + w.sizeY) / 3)
End Sub