﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

    Public iNull       As Int = 0
    Public iBlack      As Int = 1
    Public iWhite      As Int = 2
    Public iGray1      As Int = 3
    Public iGray2      As Int = 4
    Public iGreen1     As Int = 5
    Public iLemon1     As Int = 6
    Public iOrange1    As Int = 7
    Public iOrange2    As Int = 8
    Public iMagenta1   As Int = 9
    Public iViolet1    As Int = 10
    Public iCyan1      As Int = 11
    Public iRubber1    As Int = 12
    Public iWood1      As Int = 13
    Public iMetal1     As Int = 14
    Public iRoad1      As Int = 15
    Public iHullSphere As Int = 16
    Public iCount      As Int = 17	
	
	Public material() As material3
End Sub

Public Sub Initialize() As Boolean

    init
End Sub

Private Sub init()

    Dim i As Int
	Dim material(iCount) As material3
   
    For i = 0 To iCount-1
        material(i).Initialize '= New material3()
    Next
End Sub

'Public Sub setMaterial (mi As Int, albedo As Float, alpha As Float, sides As Int, c5 As color5)
Public Sub setMaterial (mi As Int, albedo As Float, alpha As Float, sides As Int, _ 
                        r4 As Int, g4 As Int, b4 As Int)

    Dim width As Float = 1.0
    Dim a4 As Int = alpha * 15

    material(mi).setup (mi, albedo, alpha, width, sides)
    material(mi).sideA.assign4 (a4, r4, g4, b4, 1.0)
    material(mi).sideB.assign4 (a4, r4, g4, b4, 0.5)
End Sub