﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals
	
	Public pan As Panel
	Public gfx As Canvas
	'Private bmp As Bitmap 
	
	Private ges As Gestures
	Private act As Activity
	Private mm As mainCls
End Sub



Public Sub Initialize(act1 As Activity, main1 As mainCls) As Boolean

	act = act1
	mm = main1
	
	pan.Initialize("") '("panel1")
	pan.Color = Colors.ARGB(0xFF, 0x22, 0x22, 0x88)
	act.AddView(pan, 0, 0, act.Width, act.Height)	
	gfx.Initialize(pan)
	
	ges.SetOnTouchListener(pan, "panel1_MuTouch")
End Sub

Private Sub panel1_MuTouch(panel1 As Object, pid As Int, action As Int, x As Float, y As Float) As Boolean

	Dim i As Int
	Dim a1 As Int = action
	
	'Log("panel1_MuTouch() x:" & x & " y:" & y)
	
	For i = 0 To ges.GetPointerCount-1
		
		pid = ges.GetPointerID(i)
		If pid >= 0 Then
			x = ges.GetX(pid)
			y = ges.GetY(pid)
			If x >= 0 AND y >= 0 Then panel1_Touch(act.ACTION_MOVE, x, y)
		End If	
	Next
	
	Select Case a1
		Case ges.ACTION_DOWN: 			panel1_Touch(act.ACTION_DOWN, x, y)
		Case ges.ACTION_POINTER_DOWN: 	panel1_Touch(act.ACTION_DOWN, x, y)
		Case ges.ACTION_UP: 			panel1_Touch(act.ACTION_UP, x, y)
		Case ges.ACTION_POINTER_UP:	 	panel1_Touch(act.ACTION_UP, x, y)
		Case ges.ACTION_MOVE:		 	panel1_Touch(act.ACTION_MOVE, x, y)
	End Select
	Return True
End Sub

Private Sub panel1_Touch(action As Int, x As Float, y As Float) As Boolean

	Dim cs As control2 = mm.input.control
	Dim w As window3 = mm.window
	Dim wx1 As Float = w.centerX + w.x1
	Dim wx2 As Float = w.centerX + w.x2
	Dim wy1 As Float = w.centerY + w.y1
	Dim wy2 As Float = w.centerY + w.y2
	Dim inside As Boolean = (x > wx1 AND x < wx2 AND y > wy1 AND y < wy2)
	Dim ltside As Boolean = (x <= wx1)
	Dim rtside As Boolean = (x >= wx2)
	Dim style As Int = mm.gpu.style
	
	'Log ("panel1_Touch(): (" & x & "," & y & ")")
	
    Select action
	    Case act.ACTION_DOWN 'ges.ACTION_DOWN 'act.ACTION_DOWN 
			
			If inside Then
				cs.active1 = 1
				cs.mx1 = x
				cs.my1 = y
				cs.mx0 = cs.mx1
				cs.my0 = cs.my1
			End If
			If ltside Then
				cs.active2 = 1
				cs.mx3 = cs.px2
				cs.my3 = y
				cs.mx2 = cs.mx3
				cs.my2 = cs.my3
			End If
			If rtside Then
				If style = mm.gpu.styleSolid Then mm.gpu.set_fillstyle(mm.gpu.styleWires)
				If style = mm.gpu.styleWires Then mm.gpu.set_fillstyle(mm.gpu.styleSolid)
			End If
			
	    Case act.ACTION_MOVE 'ges.ACTION_MOVE 'act.ACTION_MOVE
		
			If inside Then
				'cs.active1 = 1
				cs.mx1 = x
				cs.my1 = y
			End If
			If ltside Then
				'cs.active2 = 1
				cs.mx3 = cs.px2
				cs.my3 = y
			End If	
				
	    Case act.ACTION_UP 'ges.ACTION_UP 'ges.ACTION_POINTER_UP 'act.ACTION_UP
		
			If inside Then
				cs.active1 = 0
			End If
			If ltside Then
				cs.active2 = 0
			End If	
			'cs.active1 = 0
			'cs.active2 = 0
    End Select
	Return True
End Sub