﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals
	
	Type frameCls (now As Int, last As Int, rate As Int, rateS As String, show As Boolean)'NEW 
	
	Public sizeX, centerX As Double     'x-values of left and right clipping-borders
	Public sizeY, centerY As Double     'y-values of upper and lower clipping-borders
	Public x1, x2 As Double             'x-values of left and right clipping-borders, relative to center
	Public y1, y2 As Double             'y-values of upper and lower clipping-borders, relative to center
	
	Public pen0, pen1 As Int 'System.Drawing.Pen
	Public pen2, pen3 As Int 'System.Drawing.Pen
	Public pen4, pen5 As Int 'System.Drawing.Pen
	Public rec0, rec1 As Rect 'System.Drawing.Rectangle
	
	Public frame As frameCls

	Public render_speed As Int 'this is used my frmMain and control2-Class

	Public gfx As Canvas 'System.Drawing.Graphics  'graphics context for render-output ->
	Public bmp As Bitmap 'System.Drawing.Bitmap    'graphics context 
	Public pic As Panel  'System.Windows.Forms.PictureBox  'graphics context 
	Public fontface1 As Typeface 	'NEW
	Public fontsize1 As Int		 	'NEW
End Sub

Public Sub Initialize() As Boolean

	'fontface1 = Typeface.DEFAULT
	fontface1 = Typeface.CreateNew(Typeface.MONOSPACE, Typeface.STYLE_NORMAL)
	fontsize1 = 12
	
    sizeX = 0: centerX = 0: x1 = 0: x2 = 0
    sizeY = 0: centerY = 0: y1 = 0: y2 = 0 
   	
    frame.now = 0
    frame.last = 0
    frame.rate = 0
	frame.show = False 'second-elapsed-flag to update frameRate-display
    render_speed = 1

    pen0 = Colors.Black 'New Pen(Brushes.Black)
    pen1 = Colors.RGB(0x88, 0x88, 0x88) 'New Pen(Brushes.Gray)
    pen2 = Colors.RGB(0xAA, 0xAA, 0xAA) 'New Pen(Brushes.LightGray)
    pen3 = Colors.RGB(0x44, 0x44, 0x44) 'New Pen(Brushes.Black)
    pen4 = Colors.RGB(0xFF, 0xCC, 0x00) 'New Pen(Color.FromArgb(&hFF, &HCC, &h00))
    pen5 = Colors.RGB(0xFF, 0xCC, 0x00) 'New Pen(Color.FromArgb(&hFF, &H00, &h00))

    'pen0.DashStyle = Drawing2D.DashStyle.Dot
    'pen1.DashStyle = Drawing2D.DashStyle.Dot
    'pen2.DashStyle = Drawing2D.DashStyle.Dot
    'pen4.DashStyle = Drawing2D.DashStyle.Dot
    'pen5.DashStyle = Drawing2D.DashStyle.Dot

    rec0.Initialize(0,0,0,0) ' = New Rectangle()
    rec1.Initialize(0,0,0,0) ' = New Rectangle()
End Sub

'Public Sub setContext(pic0 As Panel, bmp0 As Bitmap, gfx0 As Canvas)
Public Sub setContext(pic0 As Panel, gfx0 As Canvas)

    pic = pic0
    'bmp = bmp0
    gfx = gfx0
End Sub

'aka. assignPictureBox()
'Public Sub setView(pic0 As Panel, clipScx As Float, clipScy As Float)
Public Sub setViewbox(clipScx As Float, clipScy As Float)

    sizeX = pic.Width
    sizeY = pic.Height
    centerX = pic.Width / 2
    centerY = pic.Height / 2

    x1 = -centerX * clipScx: x2 = centerX * clipScx
    y1 = -centerY * clipScy: y2 = centerY * clipScy
End Sub
	